#!/usr/bin/perl
############################################################################
#    Copyright (C) 2006 by Filippo Santovito
#    filippo.santovito@email.it
#
#    This program is free software; you can redistribute it and or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the
#    Free Software Foundation, Inc.,
#    59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
############################################################################
use warnings;
use strict;
use IPC::Open2;

chomp (my $path = shift @ARGV);
#backslash weird path
$path =~ s/([';\s])/\\$1/g;

#yakuake dcop call
my @yakuake = qw(dcop yakuake DCOPInterface);
system @yakuake;

#if yakuake is running...
if( $? == 0) {
	#... ask for a session name
	my $sessionName =  (split '/' , $path)[-1];
	my ($rdrfh, $wtrfh);
	my $pid = open2($rdrfh, $wtrfh, 'kdialog', '--inputbox', 'Insert the session name', "$sessionName");
	waitpid($pid,0);
	$sessionName = <$rdrfh>;
	#$sessionName = `kdialog --inputbox "Insert the session name" $sessionName`;
	
	#...make it visible
	system @yakuake, "slotToggleState";
	#...add a new session
	system @yakuake, "slotAddSession";
	#...get the session id
	my $session = `@yakuake selectedSession`; 
	#...run "cd $path" in the selected shell session 
	system @yakuake, "slotRunCommandInSession", "$session", "cd $path";
	#...and finally rename the session
	system @yakuake, "slotRenameSession", "$session", $sessionName;
	#good work!
	exit 0 ;
} else {
	print "yakuake not running";
	exit 1;
}
